<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>Shell.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper</a> &gt; <span class="el_source">Shell.java</span></div><h1>Shell.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/* This file copied from Hadoop's security branch,
  * with the following changes:
  * 1. package changed from org.apache.hadoop.util to
  *    org.apache.zookeeper.
  * 2. Usage of Hadoop's Configuration class removed since
  *    it is not available in Zookeeper: instead, system properties
  *    are used.
  * 3. The deprecated getUlimitMemoryCommand() method removed since
  *    it is not needed.
  */


package org.apache.zookeeper;

import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Map;
import java.util.Timer;
import java.util.TimerTask;
import java.util.concurrent.atomic.AtomicBoolean;
import org.apache.log4j.Logger;

/** 
 * A base class for running a Unix command.
 * 
 * &lt;code&gt;Shell&lt;/code&gt; can be used to run unix commands like &lt;code&gt;du&lt;/code&gt; or
 * &lt;code&gt;df&lt;/code&gt;. It also offers facilities to gate commands by 
 * time-intervals.
 */
abstract public class Shell {
  
<span class="nc" id="L52">  Logger LOG = Logger.getLogger(Shell.class);</span>
  
  /** a Unix command to get the current user's name */
  public final static String USER_NAME_COMMAND = &quot;whoami&quot;;
  /** a Unix command to get the current user's groups list */
  public static String[] getGroupsCommand() {
<span class="nc" id="L58">    return new String[]{&quot;bash&quot;, &quot;-c&quot;, &quot;groups&quot;};</span>
  }
  /** a Unix command to get a given user's groups list */
  public static String[] getGroupsForUserCommand(final String user) {
    //'groups username' command return is non-consistent across different unixes
<span class="nc" id="L63">    return new String [] {&quot;bash&quot;, &quot;-c&quot;, &quot;id -Gn &quot; + user};</span>
  }
  /** a Unix command to set permission */
  public static final String SET_PERMISSION_COMMAND = &quot;chmod&quot;;
  /** a Unix command to set owner */
  public static final String SET_OWNER_COMMAND = &quot;chown&quot;;
  public static final String SET_GROUP_COMMAND = &quot;chgrp&quot;;
  /** Return a Unix command to get permission information. */
  public static String[] getGET_PERMISSION_COMMAND() {
    //force /bin/ls, except on windows.
<span class="nc bnc" id="L73" title="All 2 branches missed.">    return new String[] {(WINDOWS ? &quot;ls&quot; : &quot;/bin/ls&quot;), &quot;-ld&quot;};</span>
  }

  /**Time after which the executing script would be timedout*/
<span class="nc" id="L77">  protected long timeOutInterval = 0L;</span>
  /** If or not script timed out*/
  private AtomicBoolean timedOut;

  /** a Unix command to get ulimit of a process. */
  public static final String ULIMIT_COMMAND = &quot;ulimit&quot;;
  
  /** 
   * Get the Unix command for setting the maximum virtual memory available
   * to a given child process. This is only relevant when we are forking a
   * process from within the Mapper or the Reducer implementations.
   * Also see Hadoop Pipes and Hadoop Streaming.
   * 
   * It also checks to ensure that we are running on a *nix platform else 
   * (e.g. in Cygwin/Windows) it returns &lt;code&gt;null&lt;/code&gt;.
   * @param memoryLimit virtual memory limit
   * @return a &lt;code&gt;String[]&lt;/code&gt; with the ulimit command arguments or 
   *         &lt;code&gt;null&lt;/code&gt; if we are running on a non *nix platform or
   *         if the limit is unspecified.
   */
  public static String[] getUlimitMemoryCommand(int memoryLimit) {
    // ulimit isn't supported on Windows
<span class="nc bnc" id="L99" title="All 2 branches missed.">    if (WINDOWS) {</span>
<span class="nc" id="L100">      return null;</span>
    }
    
<span class="nc" id="L103">    return new String[] {ULIMIT_COMMAND, &quot;-v&quot;, String.valueOf(memoryLimit)};</span>
  }

  /** Set to true on Windows platforms */
<span class="nc" id="L107">  public static final boolean WINDOWS /* borrowed from Path.WINDOWS */</span>
<span class="nc" id="L108">                = System.getProperty(&quot;os.name&quot;).startsWith(&quot;Windows&quot;);</span>
  
  private long    interval;   // refresh interval in msec
  private long    lastTime;   // last time the command was performed
  private Map&lt;String, String&gt; environment; // env for the command execution
  private File dir;
  private Process process; // sub process used to execute the command
  private int exitCode;

  /**If or not script finished executing*/
  private volatile AtomicBoolean completed;
  
  public Shell() {
<span class="nc" id="L121">    this(0L);</span>
<span class="nc" id="L122">  }</span>
  
  /**
   * @param interval the minimum duration to wait before re-executing the 
   *        command.
   */
<span class="nc" id="L128">  public Shell( long interval ) {</span>
<span class="nc" id="L129">    this.interval = interval;</span>
<span class="nc bnc" id="L130" title="All 2 branches missed.">    this.lastTime = (interval&lt;0) ? 0 : -interval;</span>
<span class="nc" id="L131">  }</span>
  
  /** set the environment for the command 
   * @param env Mapping of environment variables
   */
  protected void setEnvironment(Map&lt;String, String&gt; env) {
<span class="nc" id="L137">    this.environment = env;</span>
<span class="nc" id="L138">  }</span>

  /** set the working directory 
   * @param dir The directory where the command would be executed
   */
  protected void setWorkingDirectory(File dir) {
<span class="nc" id="L144">    this.dir = dir;</span>
<span class="nc" id="L145">  }</span>

  /** check to see if a command needs to be executed and execute if needed */
  protected void run() throws IOException {
<span class="nc bnc" id="L149" title="All 2 branches missed.">    if (lastTime + interval &gt; System.currentTimeMillis())</span>
<span class="nc" id="L150">      return;</span>
<span class="nc" id="L151">    exitCode = 0; // reset for next run</span>
<span class="nc" id="L152">    runCommand();</span>
<span class="nc" id="L153">  }</span>

  /** Run a command */
  private void runCommand() throws IOException { 
<span class="nc" id="L157">    ProcessBuilder builder = new ProcessBuilder(getExecString());</span>
<span class="nc" id="L158">    Timer timeOutTimer = null;</span>
<span class="nc" id="L159">    ShellTimeoutTimerTask timeoutTimerTask = null;</span>
<span class="nc" id="L160">    timedOut = new AtomicBoolean(false);</span>
<span class="nc" id="L161">    completed = new AtomicBoolean(false);</span>
    
<span class="nc bnc" id="L163" title="All 2 branches missed.">    if (environment != null) {</span>
<span class="nc" id="L164">      builder.environment().putAll(this.environment);</span>
    }
<span class="nc bnc" id="L166" title="All 2 branches missed.">    if (dir != null) {</span>
<span class="nc" id="L167">      builder.directory(this.dir);</span>
    }
    
<span class="nc" id="L170">    process = builder.start();</span>
<span class="nc bnc" id="L171" title="All 2 branches missed.">    if (timeOutInterval &gt; 0) {</span>
<span class="nc" id="L172">      timeOutTimer = new Timer();</span>
<span class="nc" id="L173">      timeoutTimerTask = new ShellTimeoutTimerTask(</span>
          this);
      //One time scheduling.
<span class="nc" id="L176">      timeOutTimer.schedule(timeoutTimerTask, timeOutInterval);</span>
    }
<span class="nc" id="L178">    final BufferedReader errReader = </span>
            new BufferedReader(new InputStreamReader(process
<span class="nc" id="L180">                                                     .getErrorStream()));</span>
<span class="nc" id="L181">    BufferedReader inReader = </span>
            new BufferedReader(new InputStreamReader(process
<span class="nc" id="L183">                                                     .getInputStream()));</span>
<span class="nc" id="L184">    final StringBuffer errMsg = new StringBuffer();</span>
    
    // read error and input streams as this would free up the buffers
    // free the error stream buffer
<span class="nc" id="L188">    Thread errThread = new Thread() {</span>
      @Override
      public void run() {
        try {
<span class="nc" id="L192">          String line = errReader.readLine();</span>
<span class="nc bnc" id="L193" title="All 4 branches missed.">          while((line != null) &amp;&amp; !isInterrupted()) {</span>
<span class="nc" id="L194">            errMsg.append(line);</span>
<span class="nc" id="L195">            errMsg.append(System.getProperty(&quot;line.separator&quot;));</span>
<span class="nc" id="L196">            line = errReader.readLine();</span>
          }
<span class="nc" id="L198">        } catch(IOException ioe) {</span>
<span class="nc" id="L199">          LOG.warn(&quot;Error reading the error stream&quot;, ioe);</span>
<span class="nc" id="L200">        }</span>
<span class="nc" id="L201">      }</span>
    };
    try {
<span class="nc" id="L204">      errThread.start();</span>
<span class="nc" id="L205">    } catch (IllegalStateException ise) { }</span>
    try {
<span class="nc" id="L207">      parseExecResult(inReader); // parse the output</span>
      // clear the input stream buffer
<span class="nc" id="L209">      String line = inReader.readLine();</span>
<span class="nc bnc" id="L210" title="All 2 branches missed.">      while(line != null) { </span>
<span class="nc" id="L211">        line = inReader.readLine();</span>
      }
      // wait for the process to finish and check the exit code
<span class="nc" id="L214">      exitCode  = process.waitFor();</span>
      try {
        // make sure that the error thread exits
<span class="nc" id="L217">        errThread.join();</span>
<span class="nc" id="L218">      } catch (InterruptedException ie) {</span>
<span class="nc" id="L219">        LOG.warn(&quot;Interrupted while reading the error stream&quot;, ie);</span>
<span class="nc" id="L220">      }</span>
<span class="nc" id="L221">      completed.set(true);</span>
      //the timeout thread handling
      //taken care in finally block
<span class="nc bnc" id="L224" title="All 2 branches missed.">      if (exitCode != 0) {</span>
<span class="nc" id="L225">        throw new ExitCodeException(exitCode, errMsg.toString());</span>
      }
<span class="nc" id="L227">    } catch (InterruptedException ie) {</span>
<span class="nc" id="L228">      throw new IOException(ie.toString());</span>
    } finally {
<span class="nc" id="L230">      if ((timeOutTimer!=null) &amp;&amp; !timedOut.get()) {</span>
<span class="nc" id="L231">        timeOutTimer.cancel();</span>
      }
      // close the input stream
      try {
<span class="nc" id="L235">        inReader.close();</span>
<span class="nc" id="L236">      } catch (IOException ioe) {</span>
<span class="nc" id="L237">        LOG.warn(&quot;Error while closing the input stream&quot;, ioe);</span>
<span class="nc" id="L238">      }</span>
<span class="nc bnc" id="L239" title="All 4 branches missed.">      if (!completed.get()) {</span>
<span class="nc" id="L240">        errThread.interrupt();</span>
      }
      try {
<span class="nc" id="L243">        errReader.close();</span>
<span class="nc" id="L244">      } catch (IOException ioe) {</span>
<span class="nc" id="L245">        LOG.warn(&quot;Error while closing the error stream&quot;, ioe);</span>
<span class="nc" id="L246">      }</span>
<span class="nc" id="L247">      process.destroy();</span>
<span class="nc bnc" id="L248" title="All 4 branches missed.">      lastTime = System.currentTimeMillis();</span>
<span class="nc" id="L249">    }</span>
<span class="nc bnc" id="L250" title="All 4 branches missed.">  }</span>

  /** return an array containing the command name &amp; its parameters */ 
  protected abstract String[] getExecString();
  
  /** Parse the execution result */
  protected abstract void parseExecResult(BufferedReader lines)
  throws IOException;

  /** get the current sub-process executing the given command 
   * @return process executing the command
   */
  public Process getProcess() {
<span class="nc" id="L263">    return process;</span>
  }

  /** get the exit code 
   * @return the exit code of the process
   */
  public int getExitCode() {
<span class="nc" id="L270">    return exitCode;</span>
  }

  /**
   * This is an IOException with exit code added.
   */
  public static class ExitCodeException extends IOException {
    int exitCode;
    
    public ExitCodeException(int exitCode, String message) {
<span class="nc" id="L280">      super(message);</span>
<span class="nc" id="L281">      this.exitCode = exitCode;</span>
<span class="nc" id="L282">    }</span>
    
    public int getExitCode() {
<span class="nc" id="L285">      return exitCode;</span>
    }
  }
  
  /**
   * A simple shell command executor.
   * 
   * &lt;code&gt;ShellCommandExecutor&lt;/code&gt;should be used in cases where the output 
   * of the command needs no explicit parsing and where the command, working 
   * directory and the environment remains unchanged. The output of the command 
   * is stored as-is and is expected to be small.
   */
  public static class ShellCommandExecutor extends Shell {
    
    private String[] command;
    private StringBuffer output;
    
    
    public ShellCommandExecutor(String[] execString) {
<span class="nc" id="L304">      this(execString, null);</span>
<span class="nc" id="L305">    }</span>
    
    public ShellCommandExecutor(String[] execString, File dir) {
<span class="nc" id="L308">      this(execString, dir, null);</span>
<span class="nc" id="L309">    }</span>
   
    public ShellCommandExecutor(String[] execString, File dir, 
                                 Map&lt;String, String&gt; env) {
<span class="nc" id="L313">      this(execString, dir, env , 0L);</span>
<span class="nc" id="L314">    }</span>

    /**
     * Create a new instance of the ShellCommandExecutor to execute a command.
     * 
     * @param execString The command to execute with arguments
     * @param dir If not-null, specifies the directory which should be set
     *            as the current working directory for the command.
     *            If null, the current working directory is not modified.
     * @param env If not-null, environment of the command will include the
     *            key-value pairs specified in the map. If null, the current
     *            environment is not modified.
     * @param timeout Specifies the time in milliseconds, after which the
     *                command will be killed and the status marked as timedout.
     *                If 0, the command will not be timed out. 
     */
    public ShellCommandExecutor(String[] execString, File dir, 
<span class="nc" id="L331">        Map&lt;String, String&gt; env, long timeout) {</span>
<span class="nc" id="L332">      command = execString.clone();</span>
<span class="nc bnc" id="L333" title="All 2 branches missed.">      if (dir != null) {</span>
<span class="nc" id="L334">        setWorkingDirectory(dir);</span>
      }
<span class="nc bnc" id="L336" title="All 2 branches missed.">      if (env != null) {</span>
<span class="nc" id="L337">        setEnvironment(env);</span>
      }
<span class="nc" id="L339">      timeOutInterval = timeout;</span>
<span class="nc" id="L340">    }</span>
        

    /** Execute the shell command. */
    public void execute() throws IOException {
<span class="nc" id="L345">      this.run();    </span>
<span class="nc" id="L346">    }</span>

    protected String[] getExecString() {
<span class="nc" id="L349">      return command;</span>
    }

    protected void parseExecResult(BufferedReader lines) throws IOException {
<span class="nc" id="L353">      output = new StringBuffer();</span>
<span class="nc" id="L354">      char[] buf = new char[512];</span>
      int nRead;
<span class="nc bnc" id="L356" title="All 2 branches missed.">      while ( (nRead = lines.read(buf, 0, buf.length)) &gt; 0 ) {</span>
<span class="nc" id="L357">        output.append(buf, 0, nRead);</span>
      }
<span class="nc" id="L359">    }</span>
    
    /** Get the output of the shell command.*/
    public String getOutput() {
<span class="nc bnc" id="L363" title="All 2 branches missed.">      return (output == null) ? &quot;&quot; : output.toString();</span>
    }

    /**
     * Returns the commands of this instance.
     * Arguments with spaces in are presented with quotes round; other
     * arguments are presented raw
     *
     * @return a string representation of the object.
     */
    public String toString() {
<span class="nc" id="L374">      StringBuilder builder = new StringBuilder();</span>
<span class="nc" id="L375">      String[] args = getExecString();</span>
<span class="nc bnc" id="L376" title="All 2 branches missed.">      for (String s : args) {</span>
<span class="nc bnc" id="L377" title="All 2 branches missed.">        if (s.indexOf(' ') &gt;= 0) {</span>
<span class="nc" id="L378">          builder.append('&quot;').append(s).append('&quot;');</span>
        } else {
<span class="nc" id="L380">          builder.append(s);</span>
        }
<span class="nc" id="L382">        builder.append(' ');</span>
      }
<span class="nc" id="L384">      return builder.toString();</span>
    }
  }
  
  /**
   * To check if the passed script to shell command executor timed out or
   * not.
   * 
   * @return if the script timed out.
   */
  public boolean isTimedOut() {
<span class="nc" id="L395">    return timedOut.get();</span>
  }
  
  /**
   * Set if the command has timed out.
   * 
   */
  private void setTimedOut() {
<span class="nc" id="L403">    this.timedOut.set(true);</span>
<span class="nc" id="L404">  }</span>
  
  /** 
   * Static method to execute a shell command. 
   * Covers most of the simple cases without requiring the user to implement  
   * the &lt;code&gt;Shell&lt;/code&gt; interface.
   * @param cmd shell command to execute.
   * @return the output of the executed command.
   */
  public static String execCommand(String ... cmd) throws IOException {
<span class="nc" id="L414">    return execCommand(null, cmd, 0L);</span>
  }
  
  /** 
   * Static method to execute a shell command. 
   * Covers most of the simple cases without requiring the user to implement  
   * the &lt;code&gt;Shell&lt;/code&gt; interface.
   * @param env the map of environment key=value
   * @param cmd shell command to execute.
   * @param timeout time in milliseconds after which script should be marked timeout
   * @return the output of the executed command.o
   */
  
  public static String execCommand(Map&lt;String, String&gt; env, String[] cmd,
      long timeout) throws IOException {
<span class="nc" id="L429">    ShellCommandExecutor exec = new ShellCommandExecutor(cmd, null, env, </span>
                                                          timeout);
<span class="nc" id="L431">    exec.execute();</span>
<span class="nc" id="L432">    return exec.getOutput();</span>
  }

  /** 
   * Static method to execute a shell command. 
   * Covers most of the simple cases without requiring the user to implement  
   * the &lt;code&gt;Shell&lt;/code&gt; interface.
   * @param env the map of environment key=value
   * @param cmd shell command to execute.
   * @return the output of the executed command.
   */
  public static String execCommand(Map&lt;String,String&gt; env, String ... cmd) 
  throws IOException {
<span class="nc" id="L445">    return execCommand(env, cmd, 0L);</span>
  }
  
  /**
   * Timer which is used to timeout scripts spawned off by shell.
   */
  private static class ShellTimeoutTimerTask extends TimerTask {

    private Shell shell;

<span class="nc" id="L455">    public ShellTimeoutTimerTask(Shell shell) {</span>
<span class="nc" id="L456">      this.shell = shell;</span>
<span class="nc" id="L457">    }</span>

    @Override
    public void run() {
<span class="nc" id="L461">      Process p = shell.getProcess();</span>
      try {
<span class="nc" id="L463">        p.exitValue();</span>
<span class="nc" id="L464">      } catch (Exception e) {</span>
        //Process has not terminated.
        //So check if it has completed 
        //if not just destroy it.
<span class="nc bnc" id="L468" title="All 4 branches missed.">        if (p != null &amp;&amp; !shell.completed.get()) {</span>
<span class="nc" id="L469">          shell.setTimedOut();</span>
<span class="nc" id="L470">          p.destroy();</span>
        }
<span class="nc" id="L472">      }</span>
<span class="nc" id="L473">    }</span>
  }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>